Index: doc/user-guide/Makefile
===================================================================
--- doc/user-guide/Makefile	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ doc/user-guide/Makefile	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -1,3 +1,7 @@
 -include ../../Makefile.settings
+ifdef SRCDIR
+SRCDIR := $(SRCDIR)doc/user-guide/
+endif
+
 EXTRAPARANEWLINE = 1
 # EXTRAPARANEWLINE = 0
@@ -38,5 +42,5 @@
 	chmod 0755 $(DESTDIR)$(DATADIR)
 	rm -f $(DESTDIR)$(DATADIR)/help.txt # Prevent help function from breaking in running sessions
-	install -m 0644 help.txt $(DESTDIR)$(DATADIR)/help.txt
+	install -m 0644 $(SRCDIR)help.txt $(DESTDIR)$(DATADIR)/help.txt
 
 uninstall:
Index: help.c
===================================================================
--- help.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ help.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -2,5 +2,5 @@
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2005 Wilmer van der Gaast and others                *
+  * Copyright 2002-2009 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -169,2 +169,26 @@
 	return NULL;
 }
+
+int help_add_mem( help_t **help, const char *title, const char *content )
+{
+	help_t *h, *l = NULL;
+	
+	for( h = *help; h; h = h->next )
+	{
+		if( g_strcasecmp( h->title, title ) == 0 )
+			return 0;
+		
+		l = h;
+	}
+	
+	if( l )
+		h = l->next = g_new0( struct help, 1 );
+	else
+		*help = h = g_new0( struct help, 1 );
+	h->fd = -1;
+	h->title = g_strdup( title );
+	h->length = strlen( content );
+	h->offset.mem_offset = g_strdup( content );
+	
+	return 1;
+}
Index: help.h
===================================================================
--- help.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ help.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -46,4 +46,5 @@
 void help_free( help_t **help );
 char *help_get( help_t **help, char *title );
+int help_add_mem( help_t **help, const char *title, const char *content_ );
 
 #endif
Index: ipc.c
===================================================================
--- ipc.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ ipc.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -2,5 +2,5 @@
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2006 Wilmer van der Gaast and others                *
+  * Copyright 2002-2010 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -29,8 +29,13 @@
 #include "commands.h"
 #ifndef _WIN32
+#include <sys/uio.h>
 #include <sys/un.h>
 #endif
 
 GSList *child_list = NULL;
+static int ipc_child_recv_fd = -1;
+
+static void ipc_master_takeover_fail( struct bitlbee_child *child, gboolean both );
+static gboolean ipc_send_fd( int fd, int send_fd );
 
 static void ipc_master_cmd_client( irc_t *data, char **cmd )
@@ -49,4 +54,5 @@
 	}
 	
+	/* CLIENT == On initial connects, HELLO is after /RESTARTs. */
 	if( g_strcasecmp( cmd[0], "CLIENT" ) == 0 )
 		ipc_to_children_str( "OPERMSG :Client connecting (PID=%d): %s@%s (%s)\r\n",
@@ -54,4 +60,15 @@
 }
 
+static void ipc_master_cmd_nick( irc_t *data, char **cmd )
+{
+	struct bitlbee_child *child = (void*) data;
+	
+	if( child && cmd[1] )
+	{
+		g_free( child->nick );
+		child->nick = g_strdup( cmd[1] );
+	}
+}
+
 static void ipc_master_cmd_die( irc_t *data, char **cmd )
 {
@@ -110,4 +127,99 @@
 	global.restart = -1;
 	bitlbee_shutdown( NULL, -1, 0 );
+}
+
+void ipc_master_cmd_identify( irc_t *data, char **cmd )
+{
+	struct bitlbee_child *child = (void*) data, *old = NULL;
+	char *resp;
+	GSList *l;
+	
+	if( !child || !child->nick || strcmp( child->nick, cmd[1] ) != 0 )
+		return;
+	
+	g_free( child->password );
+	child->password = g_strdup( cmd[2] );
+	
+	for( l = child_list; l; l = l->next )
+	{
+		old = l->data;
+		if( child != old &&
+		    old->nick && nick_cmp( old->nick, child->nick ) == 0 &&
+		    old->password && strcmp( old->password, child->password ) == 0 )
+			break;
+	}
+	
+	if( l && !child->to_child && !old->to_child )
+	{
+		resp = "TAKEOVER INIT\r\n";
+		child->to_child = old;
+		old->to_child = child;
+	}
+	else
+	{
+		/* Won't need the fd since we can't send it anywhere. */
+		closesocket( child->to_fd );
+		child->to_fd = -1;
+		resp = "TAKEOVER NO\r\n";
+	}
+	
+	if( write( child->ipc_fd, resp, strlen( resp ) ) != strlen( resp ) )
+		ipc_master_free_one( child );
+}
+
+
+void ipc_master_cmd_takeover( irc_t *data, char **cmd )
+{
+	struct bitlbee_child *child = (void*) data;
+	char *fwd = NULL;
+	
+	/* Normal daemon mode doesn't keep these and has simplified code for
+	   takeovers. */
+	if( child == NULL )
+		return;
+	
+	if( child->to_child == NULL ||
+	    g_slist_find( child_list, child->to_child ) == NULL )
+		return ipc_master_takeover_fail( child, FALSE );
+	
+	if( strcmp( cmd[1], "AUTH" ) == 0 )
+	{
+		/* New connection -> Master */
+		if( child->to_child &&
+		    child->nick && child->to_child->nick && cmd[2] &&
+		    child->password && child->to_child->password && cmd[3] &&
+		    strcmp( child->nick, child->to_child->nick ) == 0 &&
+		    strcmp( child->nick, cmd[2] ) == 0 &&
+		    strcmp( child->password, child->to_child->password ) == 0 &&
+		    strcmp( child->password, cmd[3] ) == 0 )
+		{
+			ipc_send_fd( child->to_child->ipc_fd, child->to_fd );
+			
+			fwd = irc_build_line( cmd );
+			if( write( child->to_child->ipc_fd, fwd, strlen( fwd ) ) != strlen( fwd ) )
+				ipc_master_free_one( child );
+			g_free( fwd );
+		}
+		else
+			return ipc_master_takeover_fail( child, TRUE );
+	}
+	else if( strcmp( cmd[1], "DONE" ) == 0 || strcmp( cmd[1], "FAIL" ) == 0 )
+	{
+		/* Old connection -> Master */
+		int fd;
+		
+		/* The copy was successful (or not), we don't need it anymore. */
+		closesocket( child->to_fd );
+		child->to_fd = -1;
+		
+		/* Pass it through to the other party, and flush all state. */
+		fwd = irc_build_line( cmd );
+		fd = child->to_child->ipc_fd;
+		child->to_child->to_child = NULL;
+		child->to_child = NULL;
+		if( write( fd, fwd, strlen( fwd ) ) != strlen( fwd ) )
+			ipc_master_free_one( child );
+		g_free( fwd );
+	}
 }
 
@@ -115,4 +227,5 @@
 	{ "client",     3, ipc_master_cmd_client,     0 },
 	{ "hello",      0, ipc_master_cmd_client,     0 },
+	{ "nick",       1, ipc_master_cmd_nick,       0 },
 	{ "die",        0, ipc_master_cmd_die,        0 },
 	{ "deaf",       0, ipc_master_cmd_deaf,       0 },
@@ -123,4 +236,6 @@
 	{ "kill",       2, NULL,                      IPC_CMD_TO_CHILDREN },
 	{ "restart",    0, ipc_master_cmd_restart,    0 },
+	{ "identify",   2, ipc_master_cmd_identify,   0 },
+	{ "takeover",   1, ipc_master_cmd_takeover,   0 },
 	{ NULL }
 };
@@ -138,5 +253,5 @@
 	
 	if( strchr( irc->umode, 'w' ) )
-		irc_write( irc, ":%s WALLOPS :%s", irc->myhost, cmd[1] );
+		irc_write( irc, ":%s WALLOPS :%s", irc->root->host, cmd[1] );
 }
 
@@ -147,5 +262,5 @@
 	
 	if( strchr( irc->umode, 's' ) )
-		irc_write( irc, ":%s NOTICE %s :%s", irc->myhost, irc->nick, cmd[1] );
+		irc_write( irc, ":%s NOTICE %s :%s", irc->root->host, irc->user->nick, cmd[1] );
 }
 
@@ -156,5 +271,5 @@
 	
 	if( strchr( irc->umode, 'o' ) )
-		irc_write( irc, ":%s NOTICE %s :*** OperMsg *** %s", irc->myhost, irc->nick, cmd[1] );
+		irc_write( irc, ":%s NOTICE %s :*** OperMsg *** %s", irc->root->host, irc->user->nick, cmd[1] );
 }
 
@@ -176,8 +291,8 @@
 		return;
 	
-	if( nick_cmp( cmd[1], irc->nick ) != 0 )
+	if( nick_cmp( cmd[1], irc->user->nick ) != 0 )
 		return;		/* It's not for us. */
 	
-	irc_write( irc, ":%s!%s@%s KILL %s :%s", irc->mynick, irc->mynick, irc->myhost, irc->nick, cmd[2] );
+	irc_write( irc, ":%s!%s@%s KILL %s :%s", irc->root->nick, irc->root->nick, irc->root->host, irc->user->nick, cmd[2] );
 	irc_abort( irc, 0, "Killed by operator: %s", cmd[2] );
 }
@@ -188,5 +303,129 @@
 		ipc_to_master_str( "HELLO\r\n" );
 	else
-		ipc_to_master_str( "HELLO %s %s :%s\r\n", irc->host, irc->nick, irc->realname );
+		ipc_to_master_str( "HELLO %s %s :%s\r\n", irc->user->host, irc->user->nick, irc->user->fullname );
+}
+
+static void ipc_child_cmd_takeover_yes( void *data );
+static void ipc_child_cmd_takeover_no( void *data );
+
+static void ipc_child_cmd_takeover( irc_t *irc, char **cmd )
+{
+	if( strcmp( cmd[1], "NO" ) == 0 )
+	{
+		/* Master->New connection */
+		/* No takeover, finish the login. */
+	}
+	else if( strcmp( cmd[1], "INIT" ) == 0 )
+	{
+		/* Master->New connection */
+		if( !set_getbool( &irc->b->set, "allow_takeover" ) )
+		{
+			ipc_child_cmd_takeover_no( irc );
+			return;
+		}
+		
+		/* Offer to take over the old session, unless for some reason
+		   we're already logging into IM connections. */
+		if( irc->login_source_id != -1 )
+			query_add( irc, NULL,
+			           "You're already connected to this server. "
+			           "Would you like to take over this session?",
+			           ipc_child_cmd_takeover_yes,
+		        	   ipc_child_cmd_takeover_no, NULL, irc );
+		
+		/* This one's going to connect to accounts, avoid that. */
+		b_event_remove( irc->login_source_id );
+		irc->login_source_id = -1;
+	}
+	else if( strcmp( cmd[1], "AUTH" ) == 0 )
+	{
+		/* Master->Old connection */
+		if( irc->password && cmd[2] && cmd[3] &&
+		    ipc_child_recv_fd != -1 &&
+		    strcmp( irc->user->nick, cmd[2] ) == 0 &&
+		    strcmp( irc->password, cmd[3] ) == 0 &&
+		    set_getbool( &irc->b->set, "allow_takeover" ) )
+		{
+			irc_switch_fd( irc, ipc_child_recv_fd );
+			irc_sync( irc );
+			irc_usermsg( irc, "You've successfully taken over your old session" );
+			ipc_child_recv_fd = -1;
+			
+			ipc_to_master_str( "TAKEOVER DONE\r\n" );
+		}
+		else
+		{
+			ipc_to_master_str( "TAKEOVER FAIL\r\n" );
+		}
+	}
+	else if( strcmp( cmd[1], "DONE" ) == 0 ) 
+	{
+		/* Master->New connection (now taken over by old process) */
+		irc_free( irc );
+	}
+	else if( strcmp( cmd[1], "FAIL" ) == 0 ) 
+	{
+		/* Master->New connection */
+		irc_usermsg( irc, "Could not take over old session" );
+	}
+}
+
+static void ipc_child_cmd_takeover_yes( void *data )
+{
+	irc_t *irc = data, *old = NULL;
+	char *to_auth[] = { "TAKEOVER", "AUTH", irc->user->nick, irc->password, NULL };
+	
+	/* Master->New connection */
+	ipc_to_master_str( "TAKEOVER AUTH %s :%s\r\n",
+	                   irc->user->nick, irc->password );
+	
+	if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		GSList *l;
+		
+		for( l = irc_connection_list; l; l = l->next )
+		{
+			old = l->data;
+			
+			if( irc != old &&
+			    irc->user->nick && old->user->nick &&
+			    irc->password && old->password &&
+			    strcmp( irc->user->nick, old->user->nick ) == 0 &&
+			    strcmp( irc->password, old->password ) == 0 )
+				break;
+		}
+		if( l == NULL )
+		{
+			to_auth[1] = "FAIL";
+			ipc_child_cmd_takeover( irc, to_auth );
+			return;
+		}
+	}
+	
+	/* Drop credentials, we'll shut down soon and shouldn't overwrite
+	   any settings. */
+	irc_usermsg( irc, "Trying to take over existing session" );
+	
+	irc_desync( irc );
+	
+	if( old )
+	{
+		ipc_child_recv_fd = dup( irc->fd );
+		ipc_child_cmd_takeover( old, to_auth );
+	}
+	
+	/* TODO: irc_setpass() should do all of this. */
+	irc_setpass( irc, NULL );
+	irc->status &= ~USTATUS_IDENTIFIED;
+	irc_umode_set( irc, "-R", 1 );
+	
+	if( old )
+		irc_abort( irc, FALSE, NULL );
+}
+
+static void ipc_child_cmd_takeover_no( void *data )
+{
+	ipc_to_master_str( "TAKEOVER NO\r\n" );
+	cmd_identify_finish( data, 0, 0 );
 }
 
@@ -199,7 +438,71 @@
 	{ "kill",       2, ipc_child_cmd_kill,        0 },
 	{ "hello",      0, ipc_child_cmd_hello,       0 },
+	{ "takeover",   1, ipc_child_cmd_takeover,    0 },
 	{ NULL }
 };
 
+gboolean ipc_child_identify( irc_t *irc )
+{
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		if( !ipc_send_fd( global.listen_socket, irc->fd ) )
+			ipc_child_disable();
+	
+		ipc_to_master_str( "IDENTIFY %s :%s\r\n", irc->user->nick, irc->password );
+		
+		return TRUE;
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		GSList *l;
+		irc_t *old;
+		char *to_init[] = { "TAKEOVER", "INIT", NULL };
+		
+		for( l = irc_connection_list; l; l = l->next )
+		{
+			old = l->data;
+			
+			if( irc != old &&
+			    irc->user->nick && old->user->nick &&
+			    irc->password && old->password &&
+			    strcmp( irc->user->nick, old->user->nick ) == 0 &&
+			    strcmp( irc->password, old->password ) == 0 )
+				break;
+		}
+		if( l == NULL ||
+		    !set_getbool( &irc->b->set, "allow_takeover" ) ||
+		    !set_getbool( &old->b->set, "allow_takeover" ) )
+			return FALSE;
+		
+		ipc_child_cmd_takeover( irc, to_init );
+		
+		return TRUE;
+	}
+	else
+		return FALSE;
+}
+
+static void ipc_master_takeover_fail( struct bitlbee_child *child, gboolean both )
+{
+	if( child == NULL || g_slist_find( child_list, child ) == NULL )
+		return;
+	
+	if( both && child->to_child != NULL )
+		ipc_master_takeover_fail( child->to_child, FALSE );
+	
+	if( child->to_fd > -1 )
+	{
+		/* Send this error only to the new connection, which can be
+		   recognised by to_fd being set. */
+		if( write( child->ipc_fd, "TAKEOVER FAIL\r\n", 15 ) != 15 )
+		{
+			ipc_master_free_one( child );
+			return;
+		}
+		close( child->to_fd );
+		child->to_fd = -1;
+	}
+	child->to_child = NULL;
+}
 
 static void ipc_command_exec( void *data, char **cmd, const command_t *commands )
@@ -230,6 +533,10 @@
 /* Return just one line. Returns NULL if something broke, an empty string
    on temporary "errors" (EAGAIN and friends). */
-static char *ipc_readline( int fd )
-{
+static char *ipc_readline( int fd, int *recv_fd )
+{
+	struct msghdr msg;
+	struct iovec iov;
+	char ccmsg[CMSG_SPACE(sizeof(recv_fd))];
+	struct cmsghdr *cmsg;
 	char buf[513], *eol;
 	int size;
@@ -253,20 +560,48 @@
 		size = eol - buf + 2;
 	
-	if( recv( fd, buf, size, 0 ) != size )
+	iov.iov_base = buf;
+	iov.iov_len = size;
+	
+	memset( &msg, 0, sizeof( msg ) );
+	msg.msg_iov = &iov;
+	msg.msg_iovlen = 1;
+	msg.msg_control = ccmsg;
+	msg.msg_controllen = sizeof( ccmsg );
+	
+	if( recvmsg( fd, &msg, 0 ) != size )
 		return NULL;
-	else
-		return g_strndup( buf, size - 2 );
+	
+	if( recv_fd )
+		for( cmsg = CMSG_FIRSTHDR( &msg ); cmsg; cmsg = CMSG_NXTHDR( &msg, cmsg ) )
+			if( cmsg->cmsg_level == SOL_SOCKET && cmsg->cmsg_type == SCM_RIGHTS )
+			{
+				/* Getting more than one shouldn't happen but if it does,
+				   make sure we don't leave them around. */
+				if( *recv_fd != -1 )
+					close( *recv_fd );
+				
+				*recv_fd = *(int*) CMSG_DATA( cmsg );
+				/*
+				fprintf( stderr, "pid %d received fd %d\n", (int) getpid(), *recv_fd );
+				*/
+			}
+	
+	/*
+	fprintf( stderr, "pid %d received: %s", (int) getpid(), buf );
+	*/
+	return g_strndup( buf, size - 2 );
 }
 
 gboolean ipc_master_read( gpointer data, gint source, b_input_condition cond )
 {
+	struct bitlbee_child *child = data;
 	char *buf, **cmd;
 	
-	if( ( buf = ipc_readline( source ) ) )
+	if( ( buf = ipc_readline( source, &child->to_fd ) ) )
 	{
 		cmd = irc_parse_line( buf );
 		if( cmd )
 		{
-			ipc_command_exec( data, cmd, ipc_master_commands );
+			ipc_command_exec( child, cmd, ipc_master_commands );
 			g_free( cmd );
 		}
@@ -285,5 +620,5 @@
 	char *buf, **cmd;
 	
-	if( ( buf = ipc_readline( source ) ) )
+	if( ( buf = ipc_readline( source, &ipc_child_recv_fd ) ) )
 	{
 		cmd = irc_parse_line( buf );
@@ -392,8 +727,5 @@
 			next = l->next;
 			if( write( c->ipc_fd, msg_buf, msg_len ) <= 0 )
-			{
 				ipc_master_free_one( c );
-				child_list = g_slist_remove( child_list, c );
-			}
 		}
 	}
@@ -413,13 +745,55 @@
 }
 
+static gboolean ipc_send_fd( int fd, int send_fd )
+{
+	struct msghdr msg;
+	struct iovec iov;
+	char ccmsg[CMSG_SPACE(sizeof(fd))];
+	struct cmsghdr *cmsg;
+	
+	memset( &msg, 0, sizeof( msg ) );
+	iov.iov_base = "0x90\r\n";         /* Ja, noppes */
+	iov.iov_len = 6;
+	msg.msg_iov = &iov;
+	msg.msg_iovlen = 1;
+	
+	msg.msg_control = ccmsg;
+	msg.msg_controllen = sizeof( ccmsg );
+	cmsg = CMSG_FIRSTHDR( &msg );
+	cmsg->cmsg_level = SOL_SOCKET;
+	cmsg->cmsg_type = SCM_RIGHTS;
+	cmsg->cmsg_len = CMSG_LEN( sizeof( send_fd ) );
+	*(int*)CMSG_DATA( cmsg ) = send_fd;
+	msg.msg_controllen = cmsg->cmsg_len;
+	
+	return sendmsg( fd, &msg, 0 ) == 6;
+}
+
 void ipc_master_free_one( struct bitlbee_child *c )
 {
+	GSList *l;
+	
 	b_event_remove( c->ipc_inpa );
 	closesocket( c->ipc_fd );
+	
+	if( c->to_fd != -1 )
+		close( c->to_fd );
 	
 	g_free( c->host );
 	g_free( c->nick );
 	g_free( c->realname );
+	g_free( c->password );
 	g_free( c );
+	
+	child_list = g_slist_remove( child_list, c );
+	
+	/* Also, if any child has a reference to this one, remove it. */
+	for( l = child_list; l; l = l->next )
+	{
+		struct bitlbee_child *oc = l->data;
+		
+		if( oc->to_child == c )
+			ipc_master_takeover_fail( oc, FALSE );
+	}
 }
 
@@ -435,5 +809,4 @@
 		{
 			ipc_master_free_one( c );
-			child_list = g_slist_remove( child_list, c );
 			break;
 		}
@@ -443,11 +816,6 @@
 void ipc_master_free_all()
 {
-	GSList *l;
-	
-	for( l = child_list; l; l = l->next )
-		ipc_master_free_one( l->data );
-	
-	g_slist_free( child_list );
-	child_list = NULL;
+	while( child_list )
+		ipc_master_free_one( child_list->data );
 }
 
@@ -506,6 +874,6 @@
 	struct bitlbee_child *child = g_new0( struct bitlbee_child, 1 );
 	
+	child->to_fd = -1;
 	child->ipc_fd = accept( serversock, NULL, 0 );
-	
 	if( child->ipc_fd == -1 )
 	{
@@ -514,7 +882,7 @@
 	}
 		
-	child->ipc_inpa = b_input_add( child->ipc_fd, GAIM_INPUT_READ, ipc_master_read, child );
-	
-	child_list = g_slist_append( child_list, child );
+	child->ipc_inpa = b_input_add( child->ipc_fd, B_EV_IO_READ, ipc_master_read, child );
+	
+	child_list = g_slist_prepend( child_list, child );
 	
 	return TRUE;
@@ -552,5 +920,5 @@
 	}
 	
-	b_input_add( serversock, GAIM_INPUT_READ, new_ipc_client, NULL );
+	b_input_add( serversock, B_EV_IO_READ, new_ipc_client, NULL );
 	
 	return 1;
@@ -597,7 +965,8 @@
 			return 0;
 		}
-		child->ipc_inpa = b_input_add( child->ipc_fd, GAIM_INPUT_READ, ipc_master_read, child );
-		
-		child_list = g_slist_append( child_list, child );
+		child->ipc_inpa = b_input_add( child->ipc_fd, B_EV_IO_READ, ipc_master_read, child );
+		child->to_fd = -1;
+		
+		child_list = g_slist_prepend( child_list, child );
 	}
 	
Index: ipc.h
===================================================================
--- ipc.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ ipc.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -2,5 +2,5 @@
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  * Copyright 2002-2010 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -37,4 +37,10 @@
 	char *nick;
 	char *realname;
+	
+	char *password;
+	
+	/* For takeovers: */
+	struct bitlbee_child *to_child;
+	int to_fd;
 };
 
@@ -48,4 +54,6 @@
 
 void ipc_child_disable();
+
+gboolean ipc_child_identify( irc_t *irc );
 
 void ipc_to_master( char **cmd );
